324d1f1db4059200b688220506df2c38b978823b
[util-vserver.git] / scripts / vapt-get
1 #! /bin/bash
2 # $Id: vapt-get,v 1.14 2005/01/27 21:24:44 ensc Exp $
3
4 # Copyright (C) 2003 Enrico Scholz <enrico.scholz@informatik.tu-chemnitz.de>
5 #  
6 # This program is free software; you can redistribute it and/or modify
7 # it under the terms of the GNU General Public License as published by
8 # the Free Software Foundation; version 2 of the License.
9 #  
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
13 # GNU General Public License for more details.
14 #  
15 # You should have received a copy of the GNU General Public License
16 # along with this program; if not, write to the Free Software
17 # Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
18
19 : ${UTIL_VSERVER_VARS:=/usr/lib/util-vserver/util-vserver-vars}
20 test -e "$UTIL_VSERVER_VARS" || {
21     echo $"Can not find util-vserver installation (the file '$UTIL_VSERVER_VARS' would be expected); aborting..." >&2
22     exit 1
23 }
24 . "$UTIL_VSERVER_VARS"
25 . "$_LIB_FUNCTIONS"
26
27
28 function showHelp()
29 {
30     echo \
31 $"Usage: $0 <vserver-name>* [--all] -- <params>+
32
33 Report bugs to <$PACKAGE_BUGREPORT>."
34     exit $1
35 }
36
37 function showVersion()
38 {
39     echo \
40 $"vapt-get $PACKAGE_VERSION -- apt-get for vservers
41 This program is part of $PACKAGE_STRING
42
43 Copyright (C) 2003 Enrico Scholz
44 This program is free software; you may redistribute it under the terms of
45 the GNU General Public License.  This program has absolutely no warranty."
46     exit $1
47 }
48
49 is_quiet=
50 declare -a vservers=()
51
52 while test "$#" -ge 1; do
53     case "$1" in
54         --)             shift; break;;
55         --help)         showHelp 0;;
56         --quiet|-q)     is_quiet=1 ;;
57         --all)
58             getAllVservers tmp
59             vservers=( "${vservers[@]}" "${tmp[@]}" )
60             ;;
61         --version)
62             showVersion 0;;
63         *)  vservers=( "${vservers[@]}" "$1" )
64      esac
65      shift
66 done
67
68 test "$#" -ge 1 || showHelp 1 >&2
69 test "${#vservers[@]}" -ne 1 || is_quiet=1
70
71 cnt=0
72 res=255
73 for i in "${vservers[@]}"; do
74     cnt=$[ cnt + 1 ]
75
76     test -n "$is_quiet" || {
77         colorize bold echo -n "vaptget: operating on vserver "
78         colorize bold colorize emph echo "$i"
79         xtermTitle "vaptget: operating on vserver '$i'  [$cnt/${#vservers[@]}]"
80     }
81     
82     if pkgmgmt.isInternal "$i"; then
83         $_VSERVER "$i" exec apt-get "$@"
84     else
85         callInNamespace "$i" \
86             "$_VNAMESPACE" --new -- "$_VAPT_GET_WORKER" "$i" "$@"
87     fi
88     res=$?
89
90     test $res -eq 0 -o -n "$is_quiet" || {
91         colorize error echo -n $"vapt-get failed on vserver '$i' with errorcode $res"
92         echo
93     }
94         
95     test -n "$is_quiet" || echo
96 done
97
98 test "$cnt" -ge 0 || echo "No vservers specified" >&2
99 exit $res